//
// Benzaiten - A Simple Game Framework.
// Copyright (C) 2008, 2009 Geisha Studios.
//
// This library is free software;  you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
//
// This library is distributed in hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
// License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this library; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
//
#if defined (HAVE_BENZAITEN_CONFIG_H)
#include <benzaiten_config.h>
#endif // !HAVE_BENZAITEN_CONFIG_H
#include "SettingsImplOSX.hpp"
#include <CoreFoundation/CFNumber.h>
#include <CoreFoundation/CFPreferences.h>
#include <CoreFoundation/CFString.h>

using namespace benzaiten;

SettingsImplOSX::SettingsImplOSX (const std::string &/*appName*/)
{
}

int
SettingsImplOSX::getInteger (const std::string &section,
        const std::string &name, int defaultValue) const
{
    std::string fullName (section + "." + name);
    CFStringRef key = CFStringCreateWithCString (NULL, fullName.c_str (),
            kCFStringEncodingASCII);
    CFNumberRef tmpValue = static_cast<CFNumberRef> (
            CFPreferencesCopyAppValue (key, kCFPreferencesCurrentApplication));
    CFRelease (key);
    int value = defaultValue;
    if ( tmpValue )
    {
        CFNumberGetValue (tmpValue, kCFNumberIntType, &value);
        CFRelease (tmpValue);
    }
    return value;
}

void
SettingsImplOSX::setInteger (const std::string &section,
        const std::string &name, int value)
{
    std::string fullName (section + "." + name);
    CFStringRef key = CFStringCreateWithCString (NULL, fullName.c_str (),
            kCFStringEncodingASCII);
    CFNumberRef tmpValue = CFNumberCreate (NULL, kCFNumberIntType, &value);
    CFPreferencesSetAppValue (key, tmpValue, kCFPreferencesCurrentApplication);
    CFRelease (tmpValue);
    CFRelease (key);
    CFPreferencesAppSynchronize (kCFPreferencesCurrentApplication);
}
